<!DOCTYPE HTML>
<html lang="de">

<head>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta charset="utf-8">
<title>Visu View</title>

<style>

.menuframe {
  font-family: Arial;
  background-color: lightgray;
  position: absolute;
  left: 0px;
  top: 0px;
  height: 30px;
  width: 100%;
  border: solid;
  font-size: medium;
  z-index: 98;
}


.msg {
  font-family: Arial;
  color: red;
  text-align: left;
  font-size: medium;
}

.divpos {
  font-family: Arial;
  text-align: left;
  position: absolute;
  left: 500px;
  top: 100px;
  width: 120px;
  height: 300px;
  background-color: lightgray;
  z-index: 99;
}


.formInpList {
  font-family: Arial;
  text-align: left;
  position: absolute;
  width: 120px;
  height: 310px;
  left: 30%;
  top: 20%;
  background-color: lightgray;
  z-index: 99;
}

.formInpText {
  font-family: Arial;
  text-align: center;
  position: absolute;
  width: 400px;
  height: 120px;
  left: 30%;
  top: 30%;
  background-color: lightgray;
  z-index: 99;
}

.signonform {
  font-family: Arial;
  text-align: left;
  position: absolute;
  left: 30%;
  top: 20%;
  width: 260px;
  height: 210px;
  background-color: lightgray;
  z-index: 99;
}

.dynitems {

}

.cancelX {
  font-family: Arial;
  display: inline-block;
  width: 95%;
  text-align: right;
  font-size: large;
}

.okbutton {
  margin-right: 10px;
  float: right;
}

.leftbutton {
  margin-left: 10px;
  float: left;
}

.textLabel {
}

.objframe {
  position:absolute;
  left:10px;
  top:40px;
  cursor:pointer;
}

.objimage {
  position:absolute;
  left:10px;
  top:40px;
  cursor:pointer;
}

.objbutton {
  position:absolute;
  left:200px;
  top:40px;
  font-weight: bold;
  cursor:pointer;
}

.objtrack {
  position:absolute;
  left:10px;
  top:40px;
  cursor:pointer;
}

.objshutter {
  position:absolute;
  left:10px;
  top:40px;
  width:170px;
  height:60px;
  cursor:pointer;
}

.objbeam {
  position:absolute;
  left:10px;
  top:40px;
  cursor:pointer;
}

.objtherm {
  position:absolute;
  left:10px;
  top:40px;
  cursor:pointer;
}

.objtext {
  position:absolute;
  text-align: center;
  left:10px;
  top:40px;
}

.txtlabel {
  position:absolute;
}

.hyperbt {
  position:absolute;
}


body {
height:100%;
<!--
background-color: MidNightBlue;
background-image: url("images/xx.jpg");
-->
background-position: 30px 50px;
background-repeat: no-repeat;

}

</style>

<link href="jquery.mobile-min.css" rel="stylesheet">
<script src="jquery.min.js"></script>
<script src="codepw.js"></script>
<script>

var SID = "0";
var ObjName = "";
var eventInterval;

var CurStateObj = "";
var CurStateImage = "";


function setCookie(name, value, exdays)
{
const d = new Date();
d.setTime(d.getTime() + (exdays*24*60*60*1000));
let expires = "expires="+ d.toUTCString();
document.cookie = name + "=" + value + ";" + expires + ";path=/";
}


function getCookie(cname)
{
name = cname + "=";
decodedCookie = decodeURIComponent(document.cookie);
ca = decodedCookie.split(';');
for(i = 0; i < ca.length; i++) {
  c = ca[i];
  while (c.charAt(0) == ' ') {
    c = c.substring(1);
    }
  if (c.indexOf(name) == 0) {
    return c.substring(name.length, c.length);
    }
  }
  return "";
}

$.urlParam = function(name){
    ParAr = window.location.href.split("?");
    var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(ParAr[1]);
    if (results == null) {
       return null;
    }
    return decodeURI(results[1]) || 0;
}


$(document).ready(function()  {

$('#viewdata').hide();
$('#objform').hide();

$('#formInpNo100').hide();
$('#formInpNo').hide();
$('#formInpTherm').hide();
$('#formInpText').hide();
$('#formInpState').hide();
$("#signonbt").hide();

$("#viewname").val(ViewName);
$("#viewcolor").val(ViewBGCol);
$("body").css('background-color', ViewBGCol);
$("#viewbgpict").val(ViewBGPict);
$("body").css({'background-image': 'url(bgimages/' + ViewBGPict + ')'});
$("body").css({'background-position': '30px 50px' });

// value when the user has released slider
$(".objtrack").on('change', TrackSetValue);

// value while moving slider
$(".objtrack").on('input', TrackUpdated);

$(window).mousedown(function(event) {
  });

$(window).mouseup(function(event) {
  });

userpassw = "";
userpassw = $.urlParam('uspw');  // from calling page

testSID = $.urlParam('SID');  // from calling page
if (testSID != undefined)  {
  SID = testSID;
  $("#signonform").hide();
  $("#signonbt").hide();
  $("#comstate").text("- aktiv - SID=" + SID);
  eventInterval = setInterval(getEvents, 3000);
  getAllObj();
  $("#viewlist").prop("disabled", false);
  return;
  }

if (userpassw == undefined)
  userpassw = getCookie('savepw');

if (userpassw != undefined)
  EEXMLRPCReq(0, "111", userpassw);

});


function getEvents()
{
if (SID != "0")
  EEXMLRPCReq(SID, "31", " ");
//date = new Date();
//console.log("getEvents at " + date);
}


function cleanString(input) {
var output = "";
for (var i=0; i < input.length; i++) {
  if ((input.charCodeAt(i) > 31) && (input.charCodeAt(i) <= 255) && (input.charCodeAt(i) != 34))  {
    output += input.charAt(i);
    }
  }
return output;
}


function ExecuteInput(MsgID, EEData)
{
//console.log(MsgID + " / " + EEData);
if (MsgID == "111")  {
  Answer = parseInt(EEData);
  if (Answer < 1)  {
    alert("Anmeldung fehlgeschlagen");
    }
  else  {
    SID = EEData;
    $("#signonform").hide();
    $("#signonbt").hide();
    $("#comstate").text("- aktiv - SID=" + SID);
    eventInterval = setInterval(getEvents, 3000);
    $("#viewlist").prop("disabled", false);
    getAllObj();
    }
  }
else {
  if (EEData == "")
    return;
  if (EEData == "*ERROR ID 1")  {
    alert("Verbindungsfehler Session-ID " + SID + " in EE nicht gefunden");
    clearInterval(eventInterval);
    $("#viewlist").prop("disabled", true);
    return;
    }
  //console.log("EEData: " + EEData);    
  items = EEData.split("%06");
 
  for (i = 0; i < items.length; i++)  {
    items[i] = cleanString(items[i]);
    }

  i = 0;
  while (i < items.length)  { 
    if (items[i].length > 2)  {  // da kann leider Muell zwischen sein
      rec = items[i].split("=");
      objname = rec[0];
      if (objname[0] != "*")  {  // hier kam *ERROR1 von EE  
        curvar = "";
        if (objname.indexOf(".") > 0)  {
          tempa = objname.split(".");
          objname = tempa[0];
          curvar = tempa[1];
          }
        curval = rec[1];
        curitem = "#" + objname;
  
        $(curitem + "value").val(curval);
        if (($("#" + objname).hasClass("objframe")) || ($("#" + objname).hasClass("objimage")))  {
          idx = parseInt(curval);
          imglist = $("#" + objname + "imglist").val().split("!");
          //console.log(imglist[idx]);
          $("#" + objname + "image").attr("src", "images/" + imglist[idx]);
          reti = $("#" + objname).attr("data-reti");
          if (reti != undefined)
            if (reti != "0")
              PutResetImage(objname, imglist[0], parseInt(reti));
          }
        else
        if ($(curitem).hasClass("objshutter"))  {
          SetShutterValue(objname, curval);
          }
        else  
        if ($(curitem).hasClass("objtherm"))  {
          if (curvar != "")  {   //Temp. oder Luftf.
            if (curvar == "TEMPERATUR")  {
              temp = parseFloat(curval).toFixed(1);
              $(curitem + "is").text(temp + "°C");
              }
            else
            if (curvar == "LUFTFEUCHTIGKEIT")  {
              $(curitem + "val2").text(curval + "%");
              }
            else
            if (curvar == "VENTILPOS")  {
              $(curitem + "val2").text("V:" + curval);
              }              
            }
          else  {
            setpoint = parseFloat(curval).toFixed(1);
            $(curitem + "value").text(setpoint + "°C");
            }
          }  
        else
        if ($(curitem).hasClass("objbeam"))  {
          min = 0;
          max = 100;
          value = parseInt(curval);
          range = $(curitem + "range").val();
          if (range != "undefined")  {
            minmax = range.split("/");
            if (minmax[0] == "") 
              minmax[0] = "0";
            if (minmax[1] == "") 
              minmax[1] = "100";  
            min = parseInt(minmax[0]);
            max = parseInt(minmax[1]);
            if (value < min)
              value = min;
            if (value > max)
              value = max;
            }
          SetBeamValue(objname, curval, min, max);
          }
        else
        if ($(curitem).hasClass("objtrack"))  {
          $(curitem + "track").val(curval);
          $(curitem + "value").text(curval);
          }
        else
        if ($(curitem).hasClass("objtext"))  {
          curval = curval.substr(0, curval.length);
          //console.log("Newvalue:" + curval);
          //$(curitem + "value").text(curval);
          $(curitem + "value").html(curval);
          }
        }
      }
    i++;
    }
  }
}


function EEXMLRPCReq(SID, MsgID, Data)
{   // MsgID 111=signon, 24=getallValues, 31=geteventbuffer, 64=setValue, 65=Button clicked
request = '<?xml version="1.0"?><methodCall><methodName>appreq</methodName><params><param><value><i4>' + SID +
          '</i4></value></param><param><value><i4>' + MsgID + '</i4></value></param><param><value><string>' + Data + '</string></value></param></params></methodCall>';

//$.post('http://127.0.0.1:2110', request, function(data) {  // wird wegen CORS abgewiesen
$.post('http://' + location.host + ':2110', request, function(data) {

  EEData = $(data).text();   // z.B.: "ANZEIGE=\"lala dada\"%06"
  //console.log("EEDATA:" + EEData);
  ExecuteInput(MsgID, EEData);
  });

}


function EESignon()
{
userpassw = $("#user").val() + "$" + $("#passw").val();

//alert("userpassw1:" + userpassw)
xb = getRandomInt(210 + 33);

userpassw = EnCodePassw(userpassw, xb);
if (getCookie("savepw") != "")  {
  var savepw = confirm("Zugangsdaten speichern und bei Seitenaufruf automatisch anmelden?");
  if (savepw) {
    setCookie('savepw', userpassw, 999999);
    }
  }

EEXMLRPCReq(0, "111", userpassw);
}


function SetBeamValue(objname, valS, min, max)
{
curitem = "#" + objname;
tmpname = curitem + "rect2";
var value = parseInt(valS);
$(tmpname).width(($(curitem).width() - 20) * (value/(max-min)));
valS = valS.replace(".", ",");
$(curitem + "value").text(valS);
}



function TrackSetValue(objname)
{
if (objname.length > 0)  {
  value = $("#" + objname + "track").val();
  $("#" + objname + "value").text(value);
  EEXMLRPCReq(SID, "64", objname + "=" + value);
  }
}

function TrackUpdated(objname)
{
if (objname.length > 0)
  $("#" + objname + "value").text($("#" + objname + "track").val());
}


function getAllObj()
{
EEXMLRPCReq(SID, "24", " ");
}


function InputNumber100(objname)
{
$("#listno100").val($("#" + objname + "value").text());
$("#formInpNo100").show();
}


function InputTherm(objname)
{
var value = $("#" + objname + "value").val(); 
$("#listTherm option:contains('" + value + "')").prop('selected', true); 
$("#formInpTherm").show();
}


function InputNumber(objname)
{
$("#inpno").val($("#" + objname + "value").text());
$("#formInpNo").show();
$("#inpno").focus();
}


function InputText(objname)
{
$("#inptext").val($("#" + objname + "value").text());
$("#formInpText").show();
$("#inptext").focus();
}


function SetShutterValue(objname, value)
{
ival = parseInt(value);
curitem = "#" + objname;
$(curitem + "rect2").height($(curitem + "rect1").height() * ((100-ival)/100));
$(curitem + "value").text(value);
}


function EnterInpNo100()
{
var count = $("#listno100 :selected").length;
if (count < 1)  {
  alert("Kein Wert ausgew&aumlhlt");
  return;
  }
var value = $("#listno100 option:selected" ).text();
if ($("#" + ObjName).hasClass("objshutter"))
  SetShutterValue(ObjName, value);
else
  $("#" + ObjName + "value").text(value);
EEXMLRPCReq(SID, "64", ObjName + "=" + value);
$("#formInpNo100").hide();
}


function EnterInpNo()
{
var valS = $("#inpno").val();
if (valS.length > 0)  {
  var value = parseInt(valS);
  curitem = "#" + ObjName;
  min = 0;
  max = 1000000;
  range = $(curitem + "range").val();
  if (range != "undefined")  {
    minmax = range.split("/");    
    if (minmax[0] == "") 
      minmax[0] = "0";
    if (minmax[1] == "") 
      minmax[1] = "100";  
    min = parseInt(minmax[0]);
    max = parseInt(minmax[1]);
    if (isNaN(max))  {
      max = min;
      min = 0;
      }
    if (value < min)
      value = min;
    if (value > max)
      value = max;
    }

  $(curitem + "value").text(valS);
  if ($(curitem).hasClass("objtrack"))
    $(curitem + "track").val(value);
  else
  if ($(curitem).hasClass("objbeam")) {
    SetBeamValue(ObjName, valS, min, max);
    }
  EEXMLRPCReq(SID, "64", ObjName + "=" + value);
  }
$("#formInpNo").hide();
}


function EnterInpTherm()
{
var count = $("#listTherm :selected").length;
if (count < 1)  {
  alert("Kein Wert ausgew&aumlhlt");
  return;
  }
var value = $("#listTherm option:selected" ).text();
$("#" + ObjName + "value").val(value);
EEXMLRPCReq(SID, "64", ObjName + "=" + value);  //debug
$("#formInpTherm").hide();
}


function ResetImage()
{
$("#" + CurStateObj + "image").attr("src", "images/" + CurStateImage);
CurStateObj = "";
CurStateImage = "";
clearInterval(resetimg);
}

function PutResetImage(ObjName, image, reti)
{
if (CurStateObj.length > 0)
  $("#" + CurStateObj + "image").attr("src", "images/" + CurStateImage);
CurStateObj = ObjName;
CurStateImage = image;
resetimg = setInterval(ResetImage, reti * 1000);
}


function EnterInpState()
{
var value = $("#liststate").val();
imglist = $("#" + ObjName + "imglist").val().split("!");
$("#" + ObjName + "image").attr("src", "images/" + imglist[parseInt(value)]);
EEXMLRPCReq(SID, "64", ObjName + "=" + value);
//alert("setvalue:" + ObjName + "=" + value);
$("#" + ObjName + "value").val(value);
$("#formInpState").hide();
/* unnötig wg. Aktualisierung über Input von EE
reti = $("#" + ObjName).attr("data-reti");
if (reti != undefined)
  if (reti != "0")
    PutResetImage(ObjName, imglist[0], parseInt(reti));
*/
}


function EnterInpText()
{
$("#" + ObjName + "value").text($("#inptext").val());
EEXMLRPCReq(SID, "64", ObjName + "=" + $("#inptext").val());
$("#formInpText").hide(); 
}


function InputStateList(objname, range)
{
ObjName = objname;
var value = parseInt($("#" + objname + "value").val()); 
var CurText = "";
items = range.split("!")
$('#liststate').empty();
cnt = parseInt(items[0]);
for (i = 1; i <= cnt; i++)  {
  val = i - 1;
  $('#liststate').append($('<option>', {value:val.toString(), text: items[i]}));
  if (val == value)
    CurText = items[i];
  }

$("#liststate option:contains('" + CurText + "')").prop('selected', true); 
$('#formInpState').show();
}

function clickedOn(objname)
{
ObjName= "";
//MsgID 64 = setValueByName, 65=Makroausführung
//alert($("#" + objname).attr("class"));
if ($("#" + objname).hasClass("objframe") || ($("#" + objname).hasClass("objimage")))  {
  curval = parseInt($("#" + objname + "value").val());
  idx = parseInt(curval);
  range = $("#" + objname + "range").val();
  items = range.split("!");
  max = parseInt(items[0]);
  if (max < 3)  {  //umschalten
    idx++;
    if (idx > 1)
      idx = 0;
    imglist = $("#" + objname + "imglist").val().split("!");
    $("#" + objname + "image").attr("src", "images/" + imglist[idx]);
    curval = idx.toString();
    $("#" + objname + "value").val(curval);
    //alert(objname + "=" + curval);
    EEXMLRPCReq(SID, "64", objname + "=" + curval);
    }
  else  {
    InputStateList(objname, range);
    }
  }
else
if ($("#" + objname).hasClass("objshutter"))  {
  ObjName = objname;
  InputNumber100(objname);
  }
else
if ($("#" + objname).hasClass("objtherm"))  {
  ObjName = objname;
  InputTherm(objname);
  }
else
if ($("#" + objname).hasClass("objbeam") || $("#" + objname).hasClass("objtrack"))  {
  ObjName = objname;
  InputNumber(objname);
  }
else
if ($("#" + objname).hasClass("objtext"))  {
  ObjName = objname;
  InputText(objname);
  }
else
if ($("#" + objname).hasClass("objbutton"))  {
  EEXMLRPCReq(SID, "65", objname);
  }
else
if ($("#" + objname).hasClass("hyperbt"))  {
  ObjName = objname;
  target = $("#" + objname).attr("data-url");
  dot = target.indexOf(".");
  if (dot > 0)
    window.open(target, '_blank');
  else
    if (target.substr(0,1) == "*")  {
      target = target.substr(1, target.length - 1);
      target = "servmain.ccc?HTM=VisuView.cls&viewname=" + target + "&uspw=" + userpassw;
      window.open(target, '_blank');
      }
    else  {
      target = "servmain.ccc?HTM=VisuView.cls&viewname=" + target + "&SID=" + SID + "&uspw=" + userpassw;
      window.location.href=target;
      }

  }
}


function signoff()
{
clearInterval(eventInterval);
EEXMLRPCReq(SID, "2", " ");
$("#comstate").text("- offline -");
$("#signonbt").show();
$("#viewlist").prop("disabled", true);
}


function signonShow()
{
$("#signonform").show();
$("#user").focus();
}

function test()
{
$("#comstate").text("- aktiv -");
$("#signonform").hide();
eventInterval = setInterval(getEvents, 3000);
}


function showSelectedView()
{
value = $("#viewlist option:selected" ).text();
if (value.length > 0)  {
  target = "servmain.ccc?HTM=VisuView.cls&viewname=" + value + "&SID=" + SID + "&uspw=" + userpassw;
  window.location.href=target;
  $("#viewlist option[value=value]").attr('selected','selected');
//  $("div.id_100 select").val("val2");
//  $("#viewlist option:selected").attr("selected", true);
  }
}


</script>
</head>

<body>

<div id="stateframe" class="menuframe">
<select id="viewlist" size=1 onchange="showSelectedView()" disabled>
<option>-Ansichten-</option>
<!--#CL
SETLUA=Pars,*PARS
LUAEXE=ViewListSize1.lua
#CL-->
</select>
&nbsp; &nbsp; &nbsp;
<button type="button" id="signonbt" onClick="signonShow()">Anmelden</button>
<label id="comstate" style="color:blue;">- offline -</label>
<button type="button" style="position:absolute; right:5px;" onclick="signoff()">Abmelden</button>
</div>

<div class="signonform" id="signonform" style="font-family: Arial; font-size: 18px; text-align: center; color: blue">
<br><b>Visualisierung</b><br><br>
<div style="font-size:16px; text-align: left">
&nbsp; &nbsp; Benutzer &nbsp;<input type="text" id="user" size=10><br><br>
&nbsp; &nbsp; Kennwort <input type="password" id="passw" size=8><br><br>
<div style="position: absolute; left: 35%">
<button type="button" onClick="EESignon()">Anmelden</button>
</div>
</div>
</div>

<div class="formInpList" id="formInpNo100">
<label class="cancelX" onClick="$('#formInpNo100').hide()">X</label><br>
<select id="listno100" size=10 style="position:absolute; left: 30%; top:10%">
<!--* LUAEXE=ListNo100.lua -->
</select>
<button type="button" style="position:absolute; left: 35%; bottom:5%;" onclick="EnterInpNo100()">OK</button>
</div>


<div class="formInpList" id="formInpTherm">
<label class="cancelX" onClick="$('#formInpTherm').hide()">X</label><br>
<select id="listTherm" size=10 style="position:absolute; left: 25%; top:10%">
<!--* LUAEXE=ListThermSets.lua -->
</select>
<button type="button" style="position:absolute; left: 35%; bottom:5%;" onclick="EnterInpTherm()">OK</button>
</div>


<div class="formInpList" id="formInpState" style="height:150px; width:300px">
<label class="cancelX" onClick="$('#formInpState').hide()">X</label><br>
<select id="liststate" size=3 style="position:absolute; left: 25%; top:10%">
<option>...</option>
</select>
<button type="button" style="position:absolute; left: 35%; bottom:5%;" onclick="EnterInpState()">OK</button>
</div>


<div class="formInpText" id="formInpNo" style="position:absolute; width:100px">
<label class="cancelX" onClick="$('#formInpNo').hide()">X</label><br><br>
<input type="number" id="inpno" size=7 style="text-align:center; top:15%;" />
<button type="button" style="position:absolute; left: 30%; bottom:10%;" onclick="EnterInpNo()">OK</button>
</div>

<div class="formInpText" id="formInpText">
<label class="cancelX" onClick="$('#formInpText').hide()">X</label><br><br>
<input type="text" id="inptext" size=24 style="text-align:center; top:15%">
<button type="button" style="position: absolute; left: 45%; bottom: 10%" onclick="EnterInpText()">OK</button>
</div>

<div class="dynitems">
</div>

<!--#CL
SETLUA=Pars,*PARS
LUAEXE=LoadView.lua
#CL-->

<br><br>
</body>
</html>
