<!DOCTYPE HTML>

<head>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta charset="utf-8">
<title>History anzeigen</title>

<style>
h1 {
  font-family: Arial;
  color: blue;
  text-align: center;
  font-size: large;
}

body {
  font-family: Arial;
  color: black;
  text-align: left;
  font-size: medium;
}

label {
  font-family: Arial;
  color: black;
  text-align: left;
  font-size: medium;
}

div {
  align-items: center;
}

.header {
  font-family: Arial;
  color: blue;
  text-align: center;
  font-size: large;
  font-weight: bold;
}

.inp {
  font-family: Arial;
  position: absolute;
  left: 190px;
  text-align: left;
  font-size: medium;
}

.formlistFrame {
  font-family: Arial;
  background-color: lightgray;
  position: absolute;
  left: 120px;
  top: 40px;
  height: 400px;
  width: 400px;
  border: solid;
  font-size: medium;
  z-index: 99;
}

.cancelX {
  font-family: Arial;
  display: inline-block;
  width: 95%;
  text-align: right;
  font-size: large;  
}

.dateblock {
  color: black;
}

.msg {
  font-family: Arial;
  color: red;
  text-align: left;
  font-size: medium;
}

.dygraph-legend {
  position: absolute;      
  background-color: rgba(200, 200, 255, 0.75);
  padding: 4px;
  border: 1px solid #000;
  border-radius: 10px;
  box-shadow: 4px 4px 4px #888;
  pointer-events: none;      
}
   
</style> 

<link href="jquery.mobile-min.css" rel="stylesheet">
<script src="jquery.min.js"></script>
<script src="CheckInputs.js"></script>
<link rel="stylesheet" href="dygraph.css">
<script src="dygraph.min.js"></script>


<script>

$.urlParam = function(name){
    ParAr = window.location.href.split("?");
    var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(ParAr[1]);
    if (results == null) {
       return null;
    }
    return decodeURI(results[1]) || 0;
}


$(document).ready(function() {
/*
erster Aufruf aus HistList:
--Pars = "HTM=showHistView.cls&FROM=HistList.cls&DFW=history.vid&viewname=AnsichtH1&btSel="
--weitere Aufrufe zur Aktualisierung:
--Pars = "HTM=showHistView.cls&FROM=showHistView.cls&viewname=AnsichtH1&DFW=history.vid&txDateFrom=2023-03-27&txTimeFrom=00%3A00&txDateTo=2023-04-03&txTimeTo=23%3A59&btShow="
*/
  
  if (typeof DefaultReadyFunc === 'function') {  
    DefaultReadyFunc(); 
    }  

  $("#viewname").val($.urlParam("viewname"));
  
  DateTo = $.urlParam("txDateTo");
  if ((DateTo != 0) && (DateTo != null)) 
    $("#txDateTo").val(DateTo);

  DateFrom = $.urlParam("txDateFrom");
  if ((DateFrom != 0) && (DateFrom != null)) 
    $("#txDateFrom").val(DateFrom);
    
  TimeFrom = $.urlParam("txTimeFrom");
  if ((TimeFrom != 0) && (TimeFrom != null))  {  
    TimeFrom = TimeFrom.replace("%3A",":");
    $("#txTimeFrom").val(TimeFrom);
    }
         
  TimeTo = $.urlParam("txTimeTo");
  if ((TimeTo != 0) || (TimeTo != null))  {
    TimeTo = TimeTo.replace("%3A",":");
    $("#txTimeTo").val(TimeTo);
    }   
              
  });


function GoBack()
{
window.location.href = 'servmain.ccc?HTM=HistList.cls';
}

function ShowDateData()  {
$('#datedata').show();
$('#allgraphs').hide();
$("#btdatedata").hide();
}

</script>                                                                   

<!--#CL
SETLUA=Pars,*PARS
LUAEXE=crtVIDFile.lua
SYSEXE=SQLiteHist.exe *PARS
LUAEXE=jsLinkHist.lua
#CL-->

</head>

<body style="margin-top:10px; margin-left:30px">
<a href="MainMenu.htm"><img src="favicon.ico" alt="MainMenu.htm" style="width: 48px; height: 48px; float: left"></a>
<h1>History anzeigen</h1>
<br>
<form name="main" action="servmain.ccc" onSubmit="Submit()">
<p id="headline" class="header"></p>

<input type="hidden" name="HTM" value="showHistView.cls">
<input type="hidden" name="FROM" value="showHistView.cls">
<input type="hidden" name="viewname" id="viewname">
<input type="hidden" name="DFW" value="history.vid">

<div id="head">
<hr>
<button type="button" onclick="window.location.href = 'MainMenu.htm'">Home</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<button type="button" onclick="window.location.href = 'servmain.ccc?HTM=HistList.cls'">History-Ansichten</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<button type="button" id="btdatedata" hidden onclick="ShowDateData();">Zeitauswahl</button>
<br><br>
<div id="datedata">
<label class="dateblock">Zeitbereich von</label><br> 
<input type=date id="txDateFrom" name="txDateFrom">
<input type=time id="txTimeFrom" name="txTimeFrom">
<br><label class="dateblock">bis</label><br>
<input type=date id="txDateTo" name="txDateTo"> 
<input type=time id="txTimeTo" name="txTimeTo">
<br><br>
<button type="submit" name="btShow" id="btShow">Aktualisieren</button><br>
</div></div>
</form>

<!--#CL
SETLUA=Pars,*PARS
LUAEXE=showGraphFiles.lua
ENDFROM
#CL--> 

</body>

</html>